#!/usr/bin/perl
use strict;
# make the necessary change to activate usbat2 functionality

# usb.c
my $usbat2_case=<<EOT;
#ifdef CONFIG_USB_STORAGE_USBAT2
                case US_PR_USBAT2:
                        ss->transport_name  = "SCM USBAT-02";
                        ss->transport = usbat2_transport;
                        ss->transport_reset = usb_stor_Bulk_reset;
                        ss->max_lun = 1;
                        break;
#endif
EOT
my $usbat2_incl=<<EOT;
#ifdef CONFIG_USB_STORAGE_USBAT2
#include "usbat2.h"
#endif
EOT
open(FH, '<usb.c') || die "Can't open usb.c: $!\n";
my $usb = join('', <FH>);
close(FH);
$usb =~ s/(#ifdef CONFIG_USB_STORAGE_JUMPSHOT\s+#incl)/$usbat2_incl$1/;
$usb =~ s/(#ifdef CONFIG_USB_STORAGE_JUMPSHOT\s+case)/$usbat2_case$1/;
open(FH, '>usb.c');
print FH $usb;
close(FH);

# transport.h
open(FH, '>>transport.h') || die "Can't open transport.h: $!\n";
print FH <<EOT;
#ifdef CONFIG_USB_STORAGE_USBAT2
#define US_PR_USBAT2  0xf6            /* SCM USBAT-02 USB Compactflash */
#endif
EOT
close(FH);

# unusual_devs
open(FH, '>>unusual_devs.h') || die "Can't open unusual_devs.h: $!\n";
print FH <<EOT;
#ifdef CONFIG_USB_STORAGE_USBAT2
#ifdef START_STOP
#define US_FL_START_STOP START_STOP
#endif
UNUSUAL_DEV(    0x0781, 0x0005, 0x0005, 0x0005,
	"Sandisk",
	"ImageMate SDDR-05b",
	US_SC_SCSI, US_PR_USBAT2, init_usbat2,
	US_FL_START_STOP | US_FL_SINGLE_LUN),
UNUSUAL_DEV(  0x04e6, 0x1010, 0x0005, 0x0005,
	"SCM",
	"SCM USBAT-02",
	US_SC_SCSI, US_PR_USBAT2, init_usbat2,
	US_FL_START_STOP | US_FL_SINGLE_LUN),
#endif
EOT
close(FH);
